

// Intterrupt gendert von INTo auf INT1
//GETESTED NUR mit ATMEGA16

/*#######################################################################################
AVR DCF77 Clock

Copyright (C) 2005 Ulrich Radig

//nderungen: Christof Ermer Regensburg
Pollin DCF...
PON High to LOW Flanke eingefgt
Umstellung auf INT1 

#######################################################################################*/


#ifndef _CLOCK_H
 #define _CLOCK_H
#define INTERRUPTSTATUS_EVENT 		0x01
#define INTERRUPTSTATUS_RISING_INT	0x02
#define INTERRUPTSTATUS_FALLING_INT	0x04
#define INTERRUPTSTATUS_DISABLED	0x08
#define INTERRUPTSTATUS_MSG			0x10
#define INTERRUPTSTATUS_SYNC		0x20


//ICH BENUTZE DEN INT1 fuer das POLLINPORT
//Ausschalten wenn nicht bentigt

#ifdef POLLIN_DCF
#define DCF_PORT				PORTD
#define DCF_DIRECTION_PORT		DDRD
#define DCF_DIRECTION_SETTING	0b00000110
#define PON			0x04
#define DATA		0x08
#endif


//ohne export
extern volatile unsigned char ss;	//Globale Variable fr Sekunden
extern volatile unsigned char mm;	//Globale Variable fr Minuten
extern volatile unsigned char hh;	//Globale Variable fr Stunden
extern volatile unsigned char day;	//Globale Variable fr den Tag
extern volatile unsigned char mon;	//Globale Variable fr den Monat
extern volatile unsigned int year;	//Globale Variable fr den Jahr

extern volatile uint32_t gu32InterruptTime;	//Melde das an andere C Module
extern volatile uint8_t gu8InterruptStatus; //Melde das an andere C Module


extern void Start_Clock (void); //Startet die DCF77 Uhr
extern void Add_one_Second (void);

//64 Bit fr DCF77 bentigt werden 59 Bits
extern volatile unsigned long long dcf_rx_buffer;
//RX Pointer (Counter)
extern volatile unsigned char rx_bit_counter;
//Hilfs Sekunden Counter
extern volatile unsigned int h_ss;

//Von mir eingefgt Christof ermer
#define MCUCR_INT1_BITMASK			0x0C // zur Abfrage

#if defined (__AVR_ATmega16__)
	//Interrupt an dem das DCF77 Modul hngt hier INT1
	#define DCF77_INT_ENABLE()	GICR |= (1<<INT1);
	#define DCF77_INT_DISABLE()	GICR &= ~(1<<INT1);
	#define DCF77_INT			INT1_vect //SIG_INTERRUPT1
	#define INT1_CONTROL		MCUCR
//RICHTIG
	//#define INT0_FALLING_EDGE	0x02
	//#define INT0_RISING_EDGE	0x03
//RICHTIG
	#define INT1_FALLING_EDGE	0x08
	#define INT1_RISING_EDGE	0x0C
	#define TIMSK1 				TIMSK
#endif

#if defined (__AVR_ATmega32__)
	//Interrupt an dem das DCF77 Modul hngt hier INT1
	#define DCF77_INT_ENABLE()	GICR |= (1<<INT1);
	#define DCF77_INT_DISABLE()	GICR &= ~(1<<INT1);
	#define DCF77_INT			INT1_vect
	#define INT1_CONTROL		MCUCR
	#define INT1_FALLING_EDGE	0x08 	// 0x02
	#define INT1_RISING_EDGE	0x0C	//0x03
	#define TIMSK1 				TIMSK
#endif

#if defined (__AVR_ATmega8__)
	//Interrupt an dem das DCF77 Modul hngt hier INT1
	#define DCF77_INT_ENABLE()	GICR |= (1<<INT1);
	#define DCF77_INT_DISABLE()	GICR &= ~(1<<INT1);
	#define DCF77_INT			INT1_vect
	#define INT1_CONTROL		MCUCR
	#define INT1_FALLING_EDGE	0x08
	#define INT1_RISING_EDGE	0x0C
    #define TIMSK1              TIMSK
#endif

#if defined (__AVR_ATmega88__)
	//Interrupt an dem das DCF77 Modul hngt hier INT1
	#define DCF77_INT_ENABLE()	EIMSK |= (1<<INT1);
	#define DCF77_INT_DISABLE()	EIMSK &= ~(1<<INT1);
	#define DCF77_INT			INT1_vect
	#define INT1_CONTROL		EICRA
	#define INT1_FALLING_EDGE	0x08
	#define INT1_RISING_EDGE	0x0C
#endif

//Structur des dcf_rx_buffer
struct  DCF77_Bits {
	unsigned char M			    :1	;
	unsigned char O1			:1	;
	unsigned char O2			:1	;
	unsigned char O3			:1	;
	unsigned char O4			:1	;
	unsigned char O5			:1	;
	unsigned char O6			:1	;
	unsigned char O7			:1	;
	unsigned char O8			:1	;
	unsigned char O9			:1	;
	unsigned char O10			:1	;
	unsigned char O11			:1	;
	unsigned char O12			:1	;
	unsigned char O13			:1	;
	unsigned char O14			:1	;
	unsigned char R			    :1	;
	unsigned char A1			:1	;
	unsigned char Z1			:1	;
	unsigned char Z2			:1	;
	unsigned char A2			:1	;
	unsigned char S			    :1	;
	unsigned char Min			:7	;//7 Bits fr die Minuten
	unsigned char P1			:1	;//Parity Minuten
	unsigned char Hour			:6	;//6 Bits fr die Stunden
	unsigned char P2			:1	;//Parity Stunden
	unsigned char Day			:6	;//6 Bits fr den Tag
	unsigned char Weekday		:3	;//3 Bits fr den Wochentag 
	unsigned char Month		    :5	;//3 Bits fr den Monat
	unsigned char Year		    :8	;//8 Bits fr das Jahr **eine 5 fr das Jahr 2005**
	unsigned char P3			:1	;//Parity von P2
	};
	
struct 
	{
	volatile char parity_err					:1	;//Hilfs Parity
	volatile char parity_P1					:1	;//Berechnetes Parity P1
	volatile char parity_P2					:1	;//Berechnetes Parity P2
	volatile char parity_P3					:1	;//Berechnetes Parity P3
	volatile char dcf_rx					:1	;//Es wurde ein Impuls empfangen
	volatile char dcf_sync					:1	;//In der letzten Minuten wurde die Uhr syncronisiert
	}flags;
	
#endif //_CLOCK_H
